Subject: Re: [BUG] git cat-file does not terminate

From: Peter Baumann <[email-masked]>
Date: Fri, 4 Mar 2011 16:40:14 +0100

On Fri, Mar 04, 2011 at 02:04:00PM +0100, Robert Wruck wrote:
> Hi,
> 
> this is some strange behaviour of cat-file:
> On a certain file, `git cat-file blob <objectname>` writes an
> endless stream repeating the first 4096 byte of the original file.
> cat-file -s and cat-file -t produce correct results.
> 
> Even stranger: This only happens with cygwin-git (1.7.4.1).
> msysgit (same machine, same repository): works
> linux-git (same machine, same repository): works
> 
> Even more strange: This only happens with cygwin on a particular
> machine (recent cygwin1.dll 1.7.8) under WinXP/32bit. On another
> machine, recent cygwin, Windows7/64bit it works...
> 
> Debugging a bit, I found that the following happens:
> In xwrite (wrapper.c), write() is called with the total file size -
> in my case about 87 MB. This call returns -1 and EAGAIN but
> nevertheless writes 4096 byte to the output fd. I don't think that's
> expected behaviour...
> 
> I "fixed" it by limiting each write to 64k (thus looping in
> write_in_full) but maybe somebody knows about that cygwin behaviour?
> 
> This seems to be the cause of the dreaded "No newline found after
> blob" when running `git svn clone` under cygwin on a repository with
> large files.
> 
> You could argue that this is a cygwin bug but maybe limiting each
> write to a maximum size is a simple workaround.
> 
Maybe you could post a patch, so everyone can see the technical implications
and discuss the fix?

-Peter